

var lWarn = {logln:function (o){}}; 
var lInfo = {logln:function (o){}};

var LOGFILE_NAME = "led-wizard.log";
lWarn = new Logger(LOGFILE_NAME);
lInfo = new Logger(LOGFILE_NAME);

function Debug(o){
	lInfo.logln(o);
}


function storeSubParameter(path, value) {
    try 
    {
        lInfo.logln("StoreSubParameter Path " + path  + " value " + value + " type " + typeof(value));
        Property.setProperty(path, value);
        Property.setFlag(path, 'ARCHIVE', true);
    }
    catch (e)
    {
        lWarn.logln("Fehler beim StoreSubParameter " + e + " Path " + path  + " value " + value);
    }        
}


function prepareCurve(oDevice,curve_id,dimmMin,dimmType,fLZ) {
	var deviceProductID=oDevice.productID;
	var deviceFirmwareID=oDevice.revisionID;
	
	if (curve_id.length!=null)
		if (curve_id<0) {
			return doCalcCurve(Math.abs(curve_id),[], 0, deviceProductID, deviceFirmwareID,false, 0);
		}

	var oCatalog=JSON.parse(curve_id);
	var dimmbar_ab=-1;
	var curve=[];
	var AnAb=0;

	for (var kIndex=0;kIndex<oCatalog.length;kIndex++) {
		curve.push({pos:oCatalog[kIndex].pos, value:oCatalog[kIndex].val});
	}
	curve.sort(function(a,b){return a.pos-b.pos;});

	lInfo.logln('calc Curfe with mindim ' + dimmMin + ' and values  ' + JSON.stringify(curve));
	if (dimmMin==-1) {
		return false;
	} else {		 
		if (AnAb>1)
			return doCalcCurve(1, curve, parseInt(''+dimmMin,10), deviceProductID, deviceFirmwareID,fLZ, parseInt(''+dimmType,10)&0x1);
		else
			return doCalcCurve(0, curve, parseInt(''+dimmMin,10), deviceProductID, deviceFirmwareID,fLZ, parseInt(''+dimmType,10)&0x1);		
	}
}

function executeProgramm(dsuid,id,dimmMin,dimmType,sMassProgPath) {
    var iIndex;
    var oParameterList;
    
    var iCount=0;
    var oPropNode=Property.getNode('massProg').getChildren();
	for (var iIndex=0;iIndex<oPropNode.length;iIndex++) {
		if (oPropNode[iIndex].getChild('state').getValue()>=0)
			iCount++;
	}

    lInfo.logln('starteProgrammierung f�r ' + dsuid + ' mit ' + id + ' queued in ' + sMassProgPath);
	 try {    

        var oDevice=getDevices().byDSID(dsuid); //throws exception if device with dsuid not found    	        
	    if (oDevice.getPropertyNode().getChild('present').getValue()==false) {
	        var sErrorMSG='Ger�t ' + dsuid + ' aktuell nicht verf�gbar';
	        lWarn.logln(sErrorMSG);
            //set the needed temp property to delete the device in the complete step 
            Property.setProperty('temp/catalogeID', raisedEvent.parameter.curveID);
            Property.setProperty('temp/dsuid', dsuid);
            Property.setProperty('temp/action', 'delete');
            Property.setProperty('temp/count', 0);
            Property.setProperty(sMassProgPath + '/state',-1);
	    } else {    	    
    	    //turn off the device before programming start
    	    new Event('led-wizard.demo',{actions:'setValue',dsuid:dsuid,value:0}).raise();    	    
    		lInfo.logln('prepareCurfe ' + dsuid + ' mit ' +id);
    		oParameterList = prepareCurve(oDevice,id,dimmMin,dimmType,false);
    		lInfo.logln('habe liste ' + oParameterList);		
    		
    		if (oParameterList != false) {
                Property.setProperty('temp/value', JSON.stringify(oParameterList));
                Property.setProperty('temp/step', 0);
                Property.setProperty('temp/catalogeID', raisedEvent.parameter.curveID);
                Property.setProperty('temp/dsuid', dsuid);
                Property.setProperty('temp/action', 'programm');
                Property.setProperty('temp/count', oParameterList.length);
    		} else {
                lWarn.logln('Fehler!: Keine Parameterliste vorhanden');
                Property.setProperty('temp/action', 'errorParamList');
                Property.setProperty('temp/count', 0);
                Property.setProperty(sMassProgPath + '/state',-1);
    		}
	    }
	    //start with first device
	    var count= Property.getNode('temp/count').getValue();
        new Event('led-wizard.answer',{type:'step',detail:'prepare',count:count,currentDevice:0,maxNrOfDevices: iCount}).raise();
        new Event('led-wizard.step',{detail:'prepare',count:count,currentDevice:0,maxNrOfDevices: iCount,massProgPath:sMassProgPath}).raise();                           
	 } 
	 catch (e) {
		 Property.setProperty(sMassProgPath + '/state',-1);
		 lWarn.logln('Exception in led-wizard-prog.executeProgramm()'  + e);
		 new Event('led-wizard.step',{detail:'complete',error:true}).raise();
		 new Event('led-wizard.answer',{type:'step',detail:'complete',error:true}).raise();
	 }
}

/**
 * Removes the device with the given dsuid from the property tree without reseting the dimming curve.
 * This function is used if a device was deleted from the dSS. 
 * @param dsuid [in] dsuid of the device to be removed
 */
function deleteDevice(dsuid) {
    lInfo.logln('starte delete device f�r ' + dsuid);
    //set the temp property for the complete step 
    Property.setProperty('temp/catalogeID', -1);
    Property.setProperty('temp/dsuid', dsuid);
    new Event('led-wizard.step',{detail:'complete',error:false}).raise();
    new Event('led-wizard.answer',{detail:'complete',type:'step',error:false}).raise();
}

function getSupplierID(curve_id) {
	var node=Property.getNode('references');
	if (node==null)
		return null;
	var oArray=node.getChildren();
	for (var iIndex=0;iIndex<oArray.length;iIndex++) {
		var iReferenceArray=JSON.parse(oArray[iIndex].getValue());
		for (var jIndex=0;jIndex<iReferenceArray.length;jIndex++)
			if (""+curve_id==""+iReferenceArray[jIndex])
				return oArray[iIndex].getName();	
	} 
	return null;
}

if (raisedEvent.parameter.actions != null) {
    lInfo.logln("Event " +  raisedEvent.parameter.actions + " will be processed");
    Property.load();
    if (raisedEvent.parameter.actions == 'massProgrammCurve') {
    	try {
    		var oArray=JSON.parse(unescape(raisedEvent.parameter.values));
    		var lIndex=0;
    		if (Property.getNode('massProg')!=null)
    			if (Property.getNode('massProg').getChildren()!=null) {
    				var oPropNode=Property.getNode('massProg').getChildren();
    				for (var iIndex=0;iIndex<oPropNode.length;iIndex++) {
    					var oNode=oPropNode[iIndex];
    					var iName=parseInt(oNode.getName(),10);
    					if (iName>=lIndex) {
    						lIndex=iName+1;
    					}
    				}
    			}
    		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
    			
    			Property.setProperty('massProg/'+ lIndex + '/dsuid',oArray[iIndex].dsuid);
    			Property.setProperty('massProg/'+ lIndex + '/curve_id',oArray[iIndex].curve_id);
    			Property.setProperty('massProg/'+ lIndex + '/state',0);
    			lIndex+=1;    	
    			
    			var oPropNode=Property.getNode('massProg').getChildren();
				for (var jIndex=0;jIndex<oPropNode.length;jIndex++) {
					var oNode=oPropNode[jIndex];
					if (oNode.getChild('state').getValue()<0)
						if (oNode.getChild('dsuid').getValue()==dsuid)
							oNode.getParent().removeChild(oNode.getName());
				}
    		}
            if ((Property.getNode('programmingStarted')==null) || (Property.getProperty('programmingStarted')==false)) {
            	Property.setProperty('programmingStarted',true);
            	new Event('led-wizard.prog',{actions:'programmCurveStartQueue'}).raise();
            } 
    		
    	} 
    	catch(e) {
   		 lWarn.logln('Exception in led-wizard-prog.massProgrammCurve'  + e);    		
    	}
    }
	if (raisedEvent.parameter.actions == 'programmCurve') {
	    try {
          
            var oIDObject=JSON.parse(unescape(raisedEvent.parameter.dsuid));
	    
        	var lIndex=0;
        	if (Property.getNode('massProg')!=null)
        		if (Property.getNode('massProg').getChildren()!=null) {
        			var oPropNode=Property.getNode('massProg').getChildren();
        			for (var iIndex=0;iIndex<oPropNode.length;iIndex++) {
        				var oNode=oPropNode[iIndex];
        				var sName=oNode.getName();
        				var iName=parseInt(oNode.getName(),10);
        				if (iName>=lIndex) {
    						lIndex=iName+1;
    					}
        			}
        		}
            
            lInfo.logln('register new ' + oIDObject.length + ' devices for programming');
            for (iIndex = 0; iIndex < oIDObject.length; iIndex++) {
                lInfo.logln('Device ' + oIDObject[iIndex]);                
                Property.setProperty('massProg/'+ lIndex + '/dsuid',oIDObject[iIndex]);
                Property.setProperty('massProg/'+ lIndex + '/curve_id',raisedEvent.parameter.curve_id);
                Property.setProperty('massProg/'+ lIndex + '/state',0);
        		lIndex+=1;
            }    
            if ((Property.getNode('programmingStarted')==null) || (Property.getProperty('programmingStarted')==false)) {
            	Property.setProperty('programmingStarted',true);
            	new Event('led-wizard.prog',{actions:'programmCurveStartQueue'}).raise();
            } 
	    }
    	catch(e) {
      		 lWarn.logln('Exception in led-wizard-prog.programmCurve'  + e);    		
       	}
    }

	if (raisedEvent.parameter.actions == 'programmCurveStartQueue') {
		/* Programm only first curve*/
	    try {
            if (Property.getNode('/scripts/led-wizard/temp') != null) {
                lInfo.logln('try to delete temp node');
                Property.getNode('/scripts/led-wizard').removeChild('temp');
            }
            if (Property.getNode('massProg')!=null)
            	if (Property.getNode('massProg').getChildren()!=null)
            		if (Property.getNode('massProg').getChildren().length>0) {
            			var iStartingIndex=-1;
            			var oMassProgArray=Property.getNode('massProg').getChildren();
            			for (var iIndex=0;((iIndex<oMassProgArray.length)&&(iStartingIndex<0));iIndex++) {
            				if (oMassProgArray[iIndex].getChild('state').getValue()==0)
            					iStartingIndex=iIndex;
            			}
            			if (iStartingIndex==-1) {            				
    						new Event('led-wizard.step',{detail:'complete',error:true}).raise();
    						new Event('led-wizard.answer',{type:'step',detail:'complete',error:true}).raise();
    						Property.setProperty('programmingStarted',false);
    						throw('detected only errors in massprog queue, so exiting');
            			}
            			var curveID=oMassProgArray[iStartingIndex].getChild('curve_id').getValue();
            			var dsuid=oMassProgArray[iStartingIndex].getChild('dsuid').getValue();
            			var sState=oMassProgArray[iStartingIndex].getChild('state').getPath();
            			var sMassProgPath=oMassProgArray[iStartingIndex].getPath();
            			Property.setProperty(sState,1);
            			
                        supplierID=getSupplierID(curveID);
                        lInfo.logln("supplier id " +supplierID);
                        if (curveID<0) {
                        	new Event('led-wizard.prog',{actions:'programmCurveValues',dsuid:dsuid,curveValue:curveID,curveID:curveID,massProg:sMassProgPath}).raise();
                        } else {                       
            	            if (Property.getNode('/scripts/led-wizard.manufacture-' + supplierID + 
            	            		                 '/myData/illuminant' + curveID + '/curves')!=null) {  
            	            	lInfo.logln('Curves already loaded, so execute it directly')
            	            	var sCurve=Property.getProperty('/scripts/led-wizard.manufacture-' + supplierID + 
            			                 '/myData/illuminant' + curveID + '/curves')
            	            	sCurve = sCurve.replace(/&amp;/g, '&').replace(/&quot;/g, '"').replace(/&lt;/g, '<').replace(/&gt;/g, '>').replace(/&#039;/g, '\'');
            	            	var dataString=Property.getProperty('/scripts/led-wizard.manufacture-' + supplierID + 
            			                 '/myData/illuminant' + curveID + '/data');
            	            	var dimmMin=null;
            	            	var dimmType=null;
            	            	if (dataString!=null) {
            	            		var oObject=JSON.parse(dataString);
            	            		dimmMin=oObject.dimmMin;
            	            		dimmType=oObject.dimmType;
            	            	} else {
            	            		throw ('datastring is null');
            	            	}
            	            	new Event('led-wizard.prog',{actions:'programmCurveValues',dsuid:dsuid,curveID:curveID,curveValue:sCurve,dimmMin:dimmMin,dimmType:dimmType,massProg:sMassProgPath}).raise();
            	            } else if (Property.getNode('/scripts/led-wizard.manufacture-' + supplierID)!=null){
            	            	if (raisedEvent.parameter.retry!=null) {
            	            		lInfo.logln('Curve for ' + dsuid + ' not found in DB, so assuming error and break the cycle, goto next step');                						
                        			storeSubParameter(sState,-2);            		
                        			Property.setProperty(sState,0);
                        			new Event('led-wizard.prog',{actions:'programmCurveStartQueue'}).raise();
            	            	} else {
                	            	lInfo.logln('Suppliers loaded, but no curves loaded');
                	            	new Event('led-wizard.query-'+ supplierID,{actions:'programmCurve'}).raise();
            	            	}
            	            } else {
            	            	if (raisedEvent.parameter.retry!=null) {
            		            	lInfo.logln('Entry for ' + dsuid + ' not found in DB, so assuming error and break the cycle, goto next step');                						
                        			storeSubParameter(sState,-1);            						
                        			new Event('led-wizard.prog',{actions:'programmCurveStartQueue'}).raise();
            	            	} else {
            		            	lInfo.logln('DB not loaded, so DB must be load before acting further');
            		            	Property.setProperty(sState,0);
            		            	new Event('led-wizard.data-static',{}).raise();
            	            	}
            	            }
                        }
            		} else
            			Property.setProperty('programmingStarted',false);
            	else
            		Property.setProperty('programmingStarted',false);
            else
            	Property.setProperty('programmingStarted',false);

	    } catch (e) {lInfo.logln('catch exception during delete temp node ' + e);}
    }
	if (raisedEvent.parameter.actions == 'programmCurveValues') {
		executeProgramm(raisedEvent.parameter.dsuid,raisedEvent.parameter.curveValue,raisedEvent.parameter.dimmMin,raisedEvent.parameter.dimmType,raisedEvent.parameter.massProg);  
	}
	if (raisedEvent.parameter.actions === 'deleteEntry') {
	    deleteDevice(raisedEvent.parameter.dsuid);
	}
}

	
